<!--
Copyright 2008, Google Inc.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. Neither the name of Google Inc. nor the names of its contributors may be
    used to endorse or promote products derived from this software without
    specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->

<!DOCTYPE html>

<html>

  <head>
    <title>Gears Console Test Page</title>
  </head>

  <body>

    <h1>Gears Console Test Page</h1>

    <div>
      <p>Log Message:</p>
      <textarea id="message" rows="6" cols="80"></textarea>
      <p>Message Arguments:<br />
      (Comma separated list of values, will be interpolated into message
      replacing instances of %s.)</p>
      [ <input id="arguments" /> ]
      <p>Log Type:</p>
      <button onclick="log('debug',
          document.getElementById('message').value);" disabled="disabled">
        debug
      </button>
      <button onclick="log('info',
          document.getElementById('message').value);" disabled="disabled">
        info
      </button>
      <button onclick="log('warn',
          document.getElementById('message').value);" disabled="disabled">
        warn
      </button>
      <button onclick="log('error',
          document.getElementById('message').value);" disabled="disabled">
        error
      </button>
      <input id="other-type" value="Custom type..."
          onfocus="if(this.value == 'Custom type...') this.value = '';" />
      <button onclick="log(
          document.getElementById('other-type').value,
          document.getElementById('message').value);" disabled="disabled">
        Custom
      </button>
    </div>
    <p>
      <input type="checkbox" id="wp" />
      <label for="wp">Send the log message from a WorkerPool process</label>
    </p>
    <p>
      <button onclick="document.getElementById('status').innerHTML = '';">
        Clear
      </button>
    </p>
    <p id="status"></p>

<!-- ====================================== -->
<!--            JavaScript code             -->

<script type="text/javascript" src="../../sdk/gears_init.js"></script>
<script type="text/javascript">
var console;
var workerPool;
var loggerWorkerId;

function addStatus(msg) {
  document.getElementById('status').insertBefore(
      document.createElement('br'),
      document.getElementById('status').firstChild);
  document.getElementById('status').insertBefore(
      document.createTextNode(msg),
      document.getElementById('status').firstChild);
}

function onlogHandler(log_event) {
  // TODO(oshlack): We could just call addStatus here to avoid duplication,
  // but the handler throws an exception about addStatus not being
  // defined if we log events too early for some reason. The exception stops
  // being thrown after a few seconds. Need to investigate the cause, but
  // this works ok for now.
  document.getElementById('status').insertBefore(
      document.createElement('br'),
      document.getElementById('status').firstChild);
  document.getElementById('status').insertBefore(
      document.createTextNode(
        "(" + log_event.type + "): " + log_event.message +
        " (" + log_event.sourceUrl + ") (" +
        // TODO(aa): Change this when log_event.date actually returns a
        // JavaScript Date object.
        Date(log_event.date) +
        ")" ),
      document.getElementById('status').firstChild);
}

function log(type, msg) {
  try {
    args = "[]";
    if (document.getElementById('arguments').value != '') {
      args = "[" + document.getElementById('arguments').value + "]";
    }
    if (document.getElementById('wp').checked) {
      addStatus('Logging message from WorkerPool process...');
      workerPool.sendMessage(type + ":_:_:" + msg + ":_:_:" + args,
                             loggerWorkerId);
    } else {
      console.log(type, msg, eval(args));
    }
  } catch (e) {
    addStatus(e.message);
  }
}

function childInit() {
  parentId = null;
  wp = google.gears.workerPool;
  wp.onmessage = childHandler;
  wp.onerror = function(e) {
                 wp.sendMessage(e.message, parentId);
                 return true;
               };
  console = google.gears.factory.create('beta.console');
}

function childHandler(message, sender) {
  parentId = sender;
  var split_message = message.split(":_:_:", 3);
  var type = split_message[0];
  var msg = split_message[1];
  var args = eval(split_message[2]);
  console.log(type, msg, args);
}

function init() {
  if (!window.google || !google.gears) {
    addStatus('Google Gears is not installed', 'error');
    return;
  }
  try {
    console = google.gears.factory.create('beta.console');
    console.onlog = onlogHandler;

    workerPool = google.gears.factory.create('beta.workerpool');
    workerPool.onmessage = function(message, sender) { addStatus(message); };

    loggerWorkerId = workerPool.createWorker(
        String(childInit) +
        String(childHandler) +
        "childInit();"
        );

  } catch (ex) {
    return;
  }
  addStatus('Ready.');
  addStatus('');
  addStatus('Messages logged here can also be viewed' +
      ' in the Log Viewer Tool.');
  addStatus('Open two copies of this page side by side' +
      ' to log between them.');
  addStatus('');
  var buttons = document.getElementsByTagName('button');
  for (var i = 0, el; el = buttons[i]; i++) {
    el.disabled = null;
  }
}

init();

</script>

</body>
</html>
